#ifndef _NEWPASSDLG_CPP
#define _NEWPASSDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <ShlObj.H>
#include <Stdio.H>
#include <ShlOBJ.H>
#include <Stdlib.H>

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../Resources/Resource.H"

#include "../Headers/NSWFL.H"
#include "../Headers/Package.H"
#include "../Headers/Entry.H"
#include "../Headers/CommonDialog.H"
#include "../Headers/FolderTree.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/NewPassDlg.H"
#include "../Dialogs/OpenPassDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND NewPassDialog_hWnd = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK NewPassDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static FolderTree MyFolderTree;

    static HMENU SystemMenu = NULL;

    static HWND BrowseTree_hWnd = NULL;
    static HWND Password1_hWnd = NULL;
    static HWND Password2_hWnd = NULL;
    static HWND PasswordBits_hWnd = NULL;
    static HWND PasswordBitsBar_hWnd = NULL;
    static HWND SaveToLocation_hWnd = NULL;
    static HWND SaveToFile_hWnd = NULL;

    //--------------------------------------------------------------------------

    if(xMessage == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        NewPassDialog_hWnd = xHandle;

        SystemMenu = GetSystemMenu(xHandle, FALSE);
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1000, "About");

        SendMessage(xHandle, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(xHandle, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

        Password1_hWnd = GetDlgItem(xHandle, IDC_PASSWORD1);
        Password2_hWnd = GetDlgItem(xHandle, IDC_PASSWORD2);
        PasswordBitsBar_hWnd = GetDlgItem(xHandle, IDC_PASSWORDBAR2);
        PasswordBits_hWnd = GetDlgItem(xHandle, IDC_PASSWORDBITS2);
        SaveToLocation_hWnd = GetDlgItem(xHandle, IDC_SAVETOLOCATION);
        SaveToFile_hWnd = GetDlgItem(xHandle, IDC_SAVETOFILE);

        BrowseTree_hWnd = GetDlgItem(xHandle, IDC_BROWSETREE);

        Set_Text(Password1_hWnd, "9e8t49e8rt4389476i516se56");
        Set_Text(Password2_hWnd, "9e8t49e8rt4389476i516se56");

        MyFolderTree.InitFolderTree(BrowseTree_hWnd, GetDlgItem(xHandle, IDC_OK), SaveToLocation_hWnd);

        char FullPath[MAX_PATH + 1];
        char Drive[MAX_PATH + 1];
        char Dir[MAX_PATH + 1];
        char File[MAX_PATH + 1];

        if(IsDirectory(gsWorkingInput))
        {
            int Length = strlen(gsWorkingInput);

            if(gsWorkingInput[Length - 1] == '\\')
            {
                gsWorkingInput[Length] = '\0';
            }

            _splitpath(gsWorkingInput, Drive, Dir, File, NULL);
            _makepath(FullPath, Drive, Dir, NULL, NULL);
            MyFolderTree.SelectPath(FullPath);

            _makepath(FullPath, NULL, NULL, File, ".pce");
            Set_Text(SaveToFile_hWnd, FullPath);
        }
        else {
            // Parse file name and location
            //_splitpath(gsWorkingInput, Drive, Dir, File, NULL);
            //_makepath(FullPath, Drive, Dir, NULL, NULL);
            //MyFolderTree.SelectPath(FullPath);
        }

        CenterWindow(xHandle);

        return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE
    }

    //--------------------------------------------------------------------------

    if(MyFolderTree.FolderTreeHandler(xHandle, xMessage, wParam, lParam))
    {
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(xMessage == 307) // Key Down
    {
        float PasswordLen1   = 0;
        float PasswordLen2    = 0;
        float EffeciencyBits = 0;

        char LocalTemp[1024];

        PasswordLen1 = (float) SendMessage(Password1_hWnd, WM_GETTEXTLENGTH, 0, 0);
        PasswordLen2 = (float) SendMessage(Password2_hWnd, WM_GETTEXTLENGTH, 0, 0);

        HWND CurrentFocus = GetFocus();

        if(CurrentFocus == Password1_hWnd)
        {
            EffeciencyBits = (PasswordLen1 / 56) * 100;
            SendMessage(PasswordBitsBar_hWnd, PBM_SETPOS, (int) EffeciencyBits, 0);
            sprintf(LocalTemp," (%.0f Bits)", PasswordLen1 * 8);
            Set_Text(PasswordBits_hWnd,LocalTemp);
        }

        if(CurrentFocus == Password2_hWnd)
        {
            EffeciencyBits = (PasswordLen2 / 56) * 100;
            SendMessage(PasswordBitsBar_hWnd, PBM_SETPOS, (int) EffeciencyBits, 0);
            sprintf(LocalTemp," (%.0f Bits)", PasswordLen2 * 8);
            Set_Text(PasswordBits_hWnd,LocalTemp);
        }
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_COMMAND)
    {
        if(wParam == IDC_OK)
        {
            char lsPassword1[1024 + 1];
            char lsPassword2[1024 + 1];

            int Length1 = Get_TextEx(Password1_hWnd, lsPassword1, 1024);
            int Length2 = Get_TextEx(Password2_hWnd, lsPassword2, 1024);

            if((Length1 < 8 || Length1 > 1024) || (Length2 < 8 || Length2 > 1024))
            {
                MessageBox(xHandle, "Please enter the same password twice. Within 8 and 1,024 characters.", gsTitleCaption, 0);
                return TRUE;
            }

            if(strcmp(lsPassword1, lsPassword2) != 0)
            {
                MessageBox(xHandle, "The passwords you entered do not match.", gsTitleCaption, 0);
                return TRUE;
            }

            char SaveToLocation[MAX_PATH + 1];
            char SaveToFile[MAX_PATH + 1];

            Length1 = Get_TextEx(SaveToLocation_hWnd, SaveToLocation, MAX_PATH);
            Length2 = Get_TextEx(SaveToFile_hWnd, SaveToFile, MAX_PATH);

            if(SaveToFile[0] == '\\' || SaveToFile[0] == '/')
            {
                int Len = strlen(SaveToLocation);
                if(SaveToLocation[Len - 1] == '\\' || SaveToLocation[Len - 1] == '/')
                {
                    SaveToLocation[Len - 1] = '\0';
                }
                strcat(SaveToLocation, SaveToFile);
            }
            else{
                int Len = strlen(SaveToLocation);
                if(SaveToLocation[Len - 1] != '\\' && SaveToLocation[Len - 1] != '/')
                {
                    strcat(SaveToLocation, "\\");;
                }
                strcat(SaveToLocation, SaveToFile);
            }

            strcpy(gsPassword, lsPassword1);
            strcpy(gsWorkingOutput, SaveToLocation);

            MyFolderTree.UnInitFolderTree();
            EndDialog(xHandle, 1);
            return TRUE;
        }

        if(wParam == IDC_CANCEL)
        {
            MyFolderTree.UnInitFolderTree();
        	EndDialog(xHandle, 0);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

	if(xMessage == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(xHandle, &ThisPS);

        // Any painting should be done here

        EndPaint(xHandle, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = xHandle;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_CLOSE)  // Received Close Message
    {
        EndDialog(xHandle, 0);
        MyFolderTree.UnInitFolderTree();
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

